// include the library construction header file

//#include <winuser.h>
#include <windows.h> 
#include <malloc.h>
#include <stdio.h>
#include <wininet.h> 


#include "pro_ext.h"
#include "lamer000.h"


static _bot_thread *bot_thread;
static DWORD ibot_thread_count=0;


// Vrt Index pro seznam thread
DWORD __intern_GetFreeThread()
    {
    DWORD liHandle=0;
    // Najdi voln msto v poli
    if (ibot_thread_count==0)
       {
       // pole nen inicalizovno
       bot_thread= (_bot_thread *) malloc(sizeof(_bot_thread));
       ZeroMemory(bot_thread,sizeof(_bot_thread));
       liHandle=ibot_thread_count++;
       }
    else
       {
       // Najdi volnou buku
       for (;liHandle < ibot_thread_count && !bot_thread[liHandle].IDThrd==0;liHandle++);

       if (liHandle >= ibot_thread_count)
          {
          liHandle=ibot_thread_count++;
          bot_thread = (_bot_thread *) realloc(bot_thread, ibot_thread_count*sizeof(_bot_thread));
		  ZeroMemory((_bot_thread *) (&bot_thread[liHandle]),sizeof(_bot_thread));
          }
       }

    return liHandle;
    }

// thread pro naten dat z URL
DWORD WINAPI  ThreadReadURL(LPVOID lpParameter)

    {
	LPVOID lpvData;
    DWORD liHandle= (DWORD) lpParameter;
    HINTERNET hSession,hURL;
    DWORD dwSize, dwMaxSize, liRet;
    VOID * szTemp[500];
    _url *Param;
    _url_data *Data;
    
    Param=(_url *) bot_thread[liHandle].Param ;
    Data=(_url_data *) bot_thread[liHandle].Data ;

    // Initialize the TLS index for this thread.  
    lpvData = (LPVOID) LocalAlloc(LPTR, 256); 
    if (TlsSetValue(bot_thread[liHandle].TlsIndex, lpvData))
       {
   
       lpvData = TlsGetValue(bot_thread[liHandle].TlsIndex);
       if (lpvData != 0) 
          LocalFree((HLOCAL) lpvData);      

       bot_thread[liHandle].nErr=0;

       // otev spojen ven
       if (bot_thread[liHandle].Cancel == 0)
          {
          hSession = InternetOpen("FoxBot_URL",
                                   INTERNET_OPEN_TYPE_PRECONFIG,
                                   NULL,
                                   NULL,
                                   0);
          if (!hSession)
             bot_thread[liHandle].State=-2;
          }


       // otevi spojen na URL
       if (bot_thread[liHandle].Cancel == 0 && hSession)
          {
          hURL = InternetOpenUrl(hSession, 
                                 Param->URL,  // Server
                                 NULL,
                                 0, 
                                 INTERNET_FLAG_RELOAD,
                                 0);
          if (!hURL)
             bot_thread[liHandle].State=-3;
          }



//_asm int 3;

       // natej data z URL a pitej je do .Data
       if (bot_thread[liHandle].Cancel == 0 && hSession && hURL)
          {
          liRet=1;
          dwMaxSize=0;
          Data->Data = (char *) malloc(sizeof(char));

          while ( bot_thread[liHandle].Cancel == 0 && liRet==1) 
             {
             dwSize=0;
             liRet=InternetReadFile (hURL, szTemp, Param->DataSize, &dwSize);
             if (liRet==1 && dwSize>0)
                {
                Data->Size=dwMaxSize+=dwSize;
                Data->Data = (LPTSTR) realloc(Data->Data, dwMaxSize*sizeof(char));
                memcpy((LPTSTR) (Data->Data)+dwMaxSize-dwSize,szTemp,dwSize);
                }

             if (liRet==1 && dwSize==0)
                {
                Data->Data = (LPTSTR) realloc(Data->Data, (dwMaxSize+1)*sizeof(char));
                *(Data->Data+dwMaxSize)=0;
                break;
                }

             if (liRet==0)
                 bot_thread[liHandle].State=-4;

             }
          }


       if (bot_thread[liHandle].Cancel == 0 && bot_thread[liHandle].State == 0)
          bot_thread[liHandle].State = 1;
       
       if (hSession)
         InternetCloseHandle(hSession);

       if (hURL)
         InternetCloseHandle(hURL);
 	   }
    return 0;
    }


// thread pro naten dat z URL dle POSTu
DWORD WINAPI  ThreadReadURLByPost(LPVOID lpParameter)
    {

	LPVOID lpvData;
    DWORD liHandle= (DWORD) lpParameter;
    HINTERNET hSession,hRequest,hConnect;
    DWORD dwSize, dwMaxSize;
    VOID * szTemp[500];
    _urlbypost *Param;
    _url_data *Data;
    int liRet;
    
    Param=(_urlbypost *) bot_thread[liHandle].Param ;
    Data=(_url_data *) bot_thread[liHandle].Data ;

//_asm int 3;

    // Initialize the TLS index for this thread.  
    lpvData = (LPVOID) LocalAlloc(LPTR, 256); 
    if (TlsSetValue(bot_thread[liHandle].TlsIndex, lpvData))
       {
   
       lpvData = TlsGetValue(bot_thread[liHandle].TlsIndex);
       if (lpvData != 0) 
          LocalFree((HLOCAL) lpvData);      

       bot_thread[liHandle].nErr=0;

       // otevi spojen ven
       if (bot_thread[liHandle].Cancel == 0)
          {
          hSession = InternetOpen("FoxBot_URL",
                                   INTERNET_OPEN_TYPE_PRECONFIG,
                                   NULL,
                                   NULL,
                                   0);
          if (!hSession)
             bot_thread[liHandle].State=-2;
          }


       // otevi spojen se serverem
       if (bot_thread[liHandle].Cancel == 0)
          {
          hConnect = InternetConnect(hSession,
                                   Param->Server,
                                   INTERNET_DEFAULT_HTTP_PORT,
                                   NULL,
                                   NULL,
                                   INTERNET_SERVICE_HTTP,0,0);
          if (!hConnect)
             bot_thread[liHandle].State=-4;
          }


       // Vytvo a odeli poadavek POST
       if (bot_thread[liHandle].Cancel == 0 && hConnect)
          {
          hRequest = HttpOpenRequest(hConnect, 
                                 "POST",
                                 Param->Object,  // objekt na serveru
                                 NULL, 
                                 NULL, 
                                 NULL, 
                                 INTERNET_FLAG_RELOAD,
                                 0);
          if (!hRequest)
             {
             bot_thread[liHandle].State=-5;
             }
          else
             {
             liRet=(int) HttpAddRequestHeaders(hRequest,
                                         Param->Header,
                                         Param->dwHeader,
                                         HTTP_ADDREQ_FLAG_ADD+HTTP_ADDREQ_FLAG_REPLACE);
             if (liRet==0)
                {
                bot_thread[liHandle].State=-6;
                }
             else
                {
                liRet=(int) HttpSendRequest(hRequest,
                                      NULL,-1,
                                      Param->Params,
                                      Param->dwParams);
                if (liRet==0)
                   {
                   bot_thread[liHandle].State=-7;
                   }

                }

             }

          }


       // natej data z URL a pitej je do .Data
       if (bot_thread[liHandle].Cancel == 0 && hSession && bot_thread[liHandle].State==0)
          {
          liRet=1;
          dwMaxSize=0;
          Data->Data = (char *) malloc(sizeof(char));

          while ( bot_thread[liHandle].Cancel == 0 && liRet==1) 
             {
             dwSize=0;
             liRet=InternetReadFile (hRequest, szTemp, Param->DataSize, &dwSize);
             if (liRet==1 && dwSize>0)
                {
                Data->Size=dwMaxSize+=dwSize;
                Data->Data = (LPTSTR) realloc(Data->Data, dwMaxSize*sizeof(char));
                memcpy((LPTSTR) (Data->Data)+dwMaxSize-dwSize,szTemp,dwSize);
                }

             if (liRet==1 && dwSize==0)
                {
                Data->Data = (LPTSTR) realloc(Data->Data, (dwMaxSize+1)*sizeof(char));
                *(Data->Data+dwMaxSize)=0;
                break;
                }

             if (liRet==0)
                 bot_thread[liHandle].State=-4;

             }
          }


       if (bot_thread[liHandle].Cancel == 0 && bot_thread[liHandle].State == 0)
          bot_thread[liHandle].State = 1;
       
       if (hSession)
         InternetCloseHandle(hSession);

       if (hConnect)
         InternetCloseHandle(hConnect);

       if (hRequest)
         InternetCloseHandle(hRequest);

 	   }

    return 0;
    }


// zahj naten URL
void FAR __extern_ReadURL(ParamBlk FAR *parm)
    {
    DWORD liHandle=0;
	Value luURL=parm->p[0].val;
    _url *Param;


/*
    // Najdi voln msto v poli
    if (ibot_thread_count==0)
       {
       // pole nen inicalizovno
       bot_thread= (_bot_thread *) malloc(sizeof(_bot_thread));
       ZeroMemory(bot_thread,sizeof(_bot_thread));
       liHandle=ibot_thread_count++;
       }
    else
       {
       // Najdi volnou buku
       for (;liHandle < ibot_thread_count && !bot_thread[liHandle].IDThrd==0;liHandle++);

       if (liHandle >= ibot_thread_count)
          {
          liHandle=ibot_thread_count++;
          bot_thread = (_bot_thread *) realloc(bot_thread, ibot_thread_count*sizeof(_bot_thread));
		  ZeroMemory((_bot_thread *) (&bot_thread[liHandle]),sizeof(_bot_thread));
          }
       }

*/
    liHandle=__intern_GetFreeThread();

    bot_thread[liHandle].Data = (_url_data *) malloc(sizeof(_url_data));
    bot_thread[liHandle].Param = (_url *) malloc(sizeof(_url));
    ZeroMemory(bot_thread[liHandle].Data,sizeof(_url_data));
    ZeroMemory(bot_thread[liHandle].Param,sizeof(_url));
    Param=(_url *) bot_thread[liHandle].Param ;
    Param->DataSize=(parm->pCount=2)?(DWORD) parm->p[1].val.ev_long:500;


    // pevezmi html strnku z VFP parametru a ulo ji do vytvoen struktury
    if ( !(_SetHandSize(luURL.ev_handle,luURL.ev_length+1) && (Param->URL= (LPTSTR) malloc(luURL.ev_length+1))) )
       _Error(182);

    _HLock(luURL.ev_handle);
   	((char FAR *) _HandToPtr(luURL.ev_handle))[luURL.ev_length] = '\0';
    if (_HandToPtr(luURL.ev_handle),luURL.ev_length)
       memcpy(Param->URL,(char* FAR) _HandToPtr(luURL.ev_handle),luURL.ev_length+1);

	_HUnLock(luURL.ev_handle);

    // Vytvo thread
    // Allocate a TLS index.
    if ((bot_thread[liHandle].TlsIndex = TlsAlloc()) != 0xFFFFFFFF) 
       {
       bot_thread[liHandle].hThrd = CreateThread(NULL,  // no security attributes 
                             0,                // use default stack size 
                             (LPTHREAD_START_ROUTINE) ThreadReadURL, 
                             (LPVOID) liHandle, // param to thread func 
                             0, // creation flag 
                             &bot_thread[liHandle].IDThrd);       // thread identifier 


       CloseHandle(bot_thread[liHandle].hThrd); // tohle jsem pidal
  	   }

    _RetInt(bot_thread[liHandle].IDThrd,11);
    }



// zahj naten URL dle poadavku POST
void FAR __extern_ReadURLByPost(ParamBlk FAR *parm)
    {
    DWORD liHandle=0;
	Value luURL=parm->p[0].val;
	Value luObject=parm->p[1].val;
	Value luParams=parm->p[2].val;
	Value luHeader=parm->p[3].val;
    _urlbypost *Param;


//if (ibot_thread_count==1)
//_BreakPoint();

/*
    // Najdi voln msto v poli
    if (ibot_thread_count==0)
       {
       // pole nen inicalizovno
       bot_thread= (_bot_thread *) malloc(sizeof(_bot_thread));
       ZeroMemory(bot_thread,sizeof(_bot_thread));
       liHandle=ibot_thread_count++;
       }
    else
       {
       // Najdi volnou buku
       for (;liHandle < ibot_thread_count && !bot_thread[liHandle].IDThrd==0;liHandle++);

       if (liHandle >= ibot_thread_count)
          {
          liHandle=ibot_thread_count++;
          bot_thread = (_bot_thread *) realloc(bot_thread, ibot_thread_count*sizeof(_bot_thread));
		  ZeroMemory((_bot_thread *) (&bot_thread[liHandle]),sizeof(_bot_thread));
          }
       }

*/
    liHandle=__intern_GetFreeThread();


    bot_thread[liHandle].Data = (_url_data *) malloc(sizeof(_url_data));
    bot_thread[liHandle].Param = (_urlbypost *) malloc(sizeof(_urlbypost));
    ZeroMemory(bot_thread[liHandle].Data,sizeof(_url_data));
    ZeroMemory(bot_thread[liHandle].Param,sizeof(_urlbypost));
    Param=(_urlbypost *) bot_thread[liHandle].Param ;
    Param->DataSize=(parm->pCount=5)?(DWORD) parm->p[4].val.ev_long:500;


    // pevezmi server z VFP parametru a ulo ji do vytvoen struktury
    if ( !(_SetHandSize(luURL.ev_handle,luURL.ev_length+1) && (Param->Server= (LPTSTR) malloc(luURL.ev_length+1))) )
       _Error(182);

    _HLock(luURL.ev_handle);
   	((char FAR *) _HandToPtr(luURL.ev_handle))[luURL.ev_length] = '\0';
    if (_HandToPtr(luURL.ev_handle),luURL.ev_length)
       memcpy(Param->Server,(char* FAR) _HandToPtr(luURL.ev_handle),luURL.ev_length+1);

	_HUnLock(luURL.ev_handle);


    // pevezmi object z VFP parametru a ulo ji do vytvoen struktury
    if ( !(_SetHandSize(luObject.ev_handle,luObject.ev_length+1) && (Param->Object= (LPTSTR) malloc(luObject.ev_length+1))) )
       _Error(182);

    _HLock(luObject.ev_handle);
   	((char FAR *) _HandToPtr(luObject.ev_handle))[luObject.ev_length] = '\0';
    if (_HandToPtr(luObject.ev_handle),luObject.ev_length)
       memcpy(Param->Object,(char* FAR) _HandToPtr(luObject.ev_handle),luObject.ev_length+1);

	_HUnLock(luObject.ev_handle);


//_BreakPoint();

    // pevezmi parametry pro POST z VFP parametru a ulo ji do vytvoen struktury
    if ( !(Param->Params= (LPTSTR) malloc(luParams.ev_length)) )
       _Error(182);

    _HLock(luParams.ev_handle);
    if (_HandToPtr(luParams.ev_handle),luParams.ev_length)
       memcpy(Param->Params,(char* FAR) _HandToPtr(luParams.ev_handle),luParams.ev_length);

    Param->dwParams=luParams.ev_length;
	_HUnLock(luParams.ev_handle);

    // pevezmi hlaviku pro POST z VFP parametru a ulo ji do vytvoen struktury
    if ( !(Param->Header= (LPTSTR) malloc(luHeader.ev_length)) )
       _Error(182);

    _HLock(luHeader.ev_handle);
    if (_HandToPtr(luHeader.ev_handle),luHeader.ev_length)
       memcpy(Param->Header,(char* FAR) _HandToPtr(luHeader.ev_handle),luHeader.ev_length);
  
    Param->dwHeader=luHeader.ev_length;
	_HUnLock(luHeader.ev_handle);


    // Vytvo thread
    // Allocate a TLS index.
    if ((bot_thread[liHandle].TlsIndex = TlsAlloc()) != 0xFFFFFFFF) 
       {
       bot_thread[liHandle].hThrd = CreateThread(NULL,  // no security attributes 
                             0,                // use default stack size 
                             (LPTHREAD_START_ROUTINE) ThreadReadURLByPost, 
                             (LPVOID) liHandle, // param to thread func 
                             0, // creation flag 
                             &bot_thread[liHandle].IDThrd);       // thread identifier 


       CloseHandle(bot_thread[liHandle].hThrd); // tohle jsem pidal
  	   }

    _RetInt(bot_thread[liHandle].IDThrd,11);
    }



// Nastav pznak peruen threadu
void FAR __extern_ThrCancel(ParamBlk FAR *parm)
    {
    DWORD liHandle=0;

    for (liHandle=0;liHandle < ibot_thread_count;liHandle++)
        {
        if (bot_thread[liHandle].IDThrd==(DWORD) parm->p[0].val.ev_long)
           break;
        }

    if (liHandle < ibot_thread_count && bot_thread[liHandle].State==1 && bot_thread[liHandle].Cancel==0)
       {
       bot_thread[liHandle].Cancel=1;
       WaitForSingleObject(bot_thread[liHandle].hThrd, WAIT_TIMEOUT); 
  	   CloseHandle(bot_thread[liHandle].hThrd); // tohle jsem pidal
       _RetInt(1,11);
       }
    else
       {
       _RetInt(-1,11);
       }
    }


// Vrt stav threadu
void FAR __extern_GetThrState(ParamBlk FAR *parm)
    {
    DWORD liHandle;

//_BreakPoint();

    for (liHandle=0;liHandle < ibot_thread_count;liHandle++)
        {
        if (bot_thread[liHandle].IDThrd==(DWORD) parm->p[0].val.ev_long)
           break;
        }

    if (liHandle < ibot_thread_count)
       {
       _RetInt((int) bot_thread[liHandle].State,11);
       }
    else
       {
       _RetInt(-1,11);
       }
    
    }

// Vrt data threadu
void FAR __extern_GetThrData(ParamBlk FAR *parm)
    {
    DWORD liHandle=0;

//_BreakPoint();

    for (liHandle=0;liHandle < ibot_thread_count;liHandle++)
        {
        if (bot_thread[liHandle].IDThrd==(DWORD) parm->p[0].val.ev_long)
           break;
        }

    if (liHandle < ibot_thread_count && (bot_thread[liHandle].State==1 || bot_thread[liHandle].State==0))
       {
       _RetInt( (int) bot_thread[liHandle].Data,11);
       }
    else
       {
       _RetInt(0,11);
       }

    }


// Uvoln data threadu
void FAR __extern_FreeThrData(ParamBlk FAR *parm)
    {
    DWORD liHandle=0;

    for (liHandle=0;liHandle < ibot_thread_count;liHandle++)
        {
        if (bot_thread[liHandle].IDThrd==(DWORD) parm->p[0].val.ev_long)
           break;
        }

//_BreakPoint();

    if (liHandle < ibot_thread_count) // && (bot_thread[liHandle].State==1 || bot_thread[liHandle].Cancel==1)
       {
       bot_thread[liHandle].hThrd=0;
       free((_url_data *) bot_thread[liHandle].Data);
       free((_url *) bot_thread[liHandle].Param);

//       bot_thread[liHandle].Param = (LPTSTR) realloc(bot_thread[liHandle].Data, sizeof(char));
//       bot_thread[liHandle].Data = (LPTSTR) realloc(bot_thread[liHandle].Data, sizeof(char));

       bot_thread[liHandle].State=0;
       bot_thread[liHandle].Cancel=0;
       bot_thread[liHandle].TlsIndex=0;
       bot_thread[liHandle].IDThrd=0;
       _RetInt(1,11);
       }
    else
       {
       _RetInt(-1,11);
       }

    }


FoxInfo myFoxInfo[] = {
	{"bot_ReadURL",(FPFI) __extern_ReadURL, 2,"C.I"},
	{"bot_ReadURLByPost",(FPFI) __extern_ReadURLByPost, 5,"CCCC.I"},
	{"bot_GetThrState",(FPFI) __extern_GetThrState, 1,"I"},
	{"bot_GetThrData",(FPFI) __extern_GetThrData, 1,"I"},
	{"bot_ThrCancel",(FPFI) __extern_ThrCancel, 1,"I"},
	{"bot_FreeThrData",(FPFI) __extern_FreeThrData, 1,"I"},
};



extern "C" 
{
	// the FoxTable structure
	FoxTable _FoxTable = {
		(FoxTable  *) 0, sizeof(myFoxInfo)/sizeof(FoxInfo), myFoxInfo
	};

}


